import { SyncHook } from "tapable-ts";
import type { Navigation, NavigationFlowEndState } from "@player-ui/types";
import type { Logger } from "../../logger";
import type { TransitionOptions } from "./flow";
import { FlowInstance } from "./flow";
/** A manager for the navigation section of a Content blob */
export declare class FlowController {
    readonly hooks: {
        flow: SyncHook<[FlowInstance], Record<string, any>>;
    };
    private readonly log?;
    private navigation;
    private navStack;
    current?: FlowInstance;
    constructor(navigation: Navigation, options?: {
        /** A logger instance to use */
        logger?: Logger;
    });
    /** Navigate to another state in the state-machine */
    transition(stateTransition: string, options?: TransitionOptions): void;
    private addNewFlow;
    private run;
    start(): Promise<NavigationFlowEndState>;
}
//# sourceMappingURL=controller.d.ts.map