import type { Node } from "../../view";
import { LocalStateStore } from "./store";
import type { TransformRegistry } from "./types";
import type { ViewController } from "./controller";
/**
 * A plugin to register custom transforms on certain asset types
 * This allows users to embed stateful data into transforms.
 */
export declare class AssetTransformCorePlugin {
    readonly stateStore: Map<Node.Node, LocalStateStore>;
    private readonly registry;
    private beforeResolveSymbol;
    private resolveSymbol;
    private beforeResolveCountSymbol;
    private resolveCountSymbol;
    constructor(registry: TransformRegistry);
    apply(viewController: ViewController): void;
}
//# sourceMappingURL=asset-transform.d.ts.map