import type { ErrorWithLocation, ExpressionHandler, ExpressionNode, ExpressionObjectType, ExpressionType, NodePosition } from "./types";
/** Generates a function by removing the first context argument */
export declare function withoutContext<T extends unknown[], Return>(fn: (...args: T) => Return): ExpressionHandler<T, Return>;
/** Get the node in the expression that's closest to the desired position */
export declare function findClosestNodeAtPosition(node: ExpressionNode, position: NodePosition): ExpressionNode | undefined;
/** Checks if the expression is a simple type */
export declare function isObjectExpression(expr: ExpressionType): expr is ExpressionObjectType;
/**
 * Type guard for ErrorWithLocation
 */
export declare function isErrorWithLocation(error: Error): error is ErrorWithLocation;
//# sourceMappingURL=utils.d.ts.map