import type { Logger, Severity } from "./types";
export type ConsoleHandler = Pick<typeof console, "log" | "warn" | "error">;
/** A Logger implementation that uses console */
export default class ConsoleLogger implements Logger {
    private severity;
    private _console;
    constructor(severity?: Severity, _console?: ConsoleHandler);
    setSeverity(severity: Severity): void;
    private getConsoleFn;
    private createHandler;
    readonly trace: (...args: any[]) => void;
    readonly debug: (...args: any[]) => void;
    readonly info: (...args: any[]) => void;
    readonly warn: (...args: any[]) => void;
    readonly error: (...args: any[]) => void;
}
//# sourceMappingURL=consoleLogger.d.ts.map