import { SyncHook } from "tapable-ts";
import type { Logger } from "./types";
/** A logger that has a tapable subscriptions to callbacks */
export default class TapableLogger implements Logger {
    readonly hooks: {
        trace: SyncHook<[any[]], Record<string, any>>;
        debug: SyncHook<[any[]], Record<string, any>>;
        info: SyncHook<[any[]], Record<string, any>>;
        warn: SyncHook<[any[]], Record<string, any>>;
        error: SyncHook<[any[]], Record<string, any>>;
        log: SyncHook<["error" | "trace" | "debug" | "info" | "warn", any[]], Record<string, any>>;
    };
    private logHandlers;
    private createHandler;
    addHandler(logHandler: Logger): void;
    removeHandler(logHandler: Logger): void;
    readonly trace: (...args: any[]) => void;
    readonly debug: (...args: any[]) => void;
    readonly info: (...args: any[]) => void;
    readonly warn: (...args: any[]) => void;
    readonly error: (...args: any[]) => void;
}
//# sourceMappingURL=tapableLogger.d.ts.map